
!ImageSavePacer classSide methodsFor: '*DevPacerPharo14' stamp: 'hjo 4/20/2012 17:30'!
initialize

	self registerToAnnouncements.! !

!ImageSavePacer classSide methodsFor: '*DevPacerPharo14' stamp: 'hjo 4/20/2012 15:13'!
registerToAnnouncements

	SystemAnnouncer announcer weak
		on: CategoryAdded send: #systemChanged to: self;
		on: CategoryRemoved send: #systemChanged to: self;
		on: CategoryRenamed send: #systemChanged to: self;
		on: ClassAdded send: #systemChanged to: self;
		on: ClassCommented send: #systemChanged to: self;
		on: ClassModifiedClassDefinition send: #systemChanged to: self;
		on: ClassRecategorized send: #systemChanged to: self;
		on: ClassRemoved send: #systemChanged to: self;
		on: ClassRenamed send: #systemChanged to: self;
		on: ClassReorganized send: #systemChanged to: self;
		on: MethodAdded send: #systemChanged to: self;
		on: MethodModified send: #systemChanged to: self;
		on: MethodRecategorized send: #systemChanged to: self;
		on: MethodRemoved send: #systemChanged to: self;
		on: ProtocolAdded send: #systemChanged to: self;
		on: ProtocolRemoved send: #systemChanged to: self;
		on: UnknownSystemChange send: #systemChanged to: self
! !

!SmalltalkImage methodsFor: '*DevPacerPharo14' stamp: 'hjo 4/20/2012 17:15'!
snapshot: save andQuit: quit
	"Mark the changes file and close all files as part of #processShutdownList.
	If save is true, save the current state of this Smalltalk in the image file.
	If quit is true, then exit to the outer OS shell.
	The latter part of this method runs when resuming a previously saved image. This resume logic checks for a document file to process when starting up."

	| snapshotResult resuming startupErrors |
	"BEGIN PATCH DevPacer"
	save ifTrue: [ImageSavePacer systemSaved].
	"END PATCH DevPacer"
	Object flushDependents.
	Object flushEvents.

	self addSnapshotRecord: save andQuit: quit.
	self processShutDownList: quit.
									
	save
		ifTrue: [ 
			snapshotResult := self snapshotPrimitive.	"<-- PC frozen here on image file"
			resuming := snapshotResult == true ]
		ifFalse: [ resuming := false ].
	(quit and: [ resuming not ])
		ifTrue: [ self quitPrimitive ].
	
	self vm setGCParameters.
	
	deferredStartupActions := nil.
	resuming
		ifTrue: [ Smalltalk clearExternalObjects ].
	
	startupErrors := OrderedCollection new.
	
	UIManager default boot: resuming during: [
		startupErrors addAll: (self processStartUpList: resuming).
		resuming
			ifTrue: [ self recordStartupStamp ]].
	startupErrors addAll: (self executeDeferredStartupActions: resuming).
	
	startupErrors isEmpty 
		ifFalse: [ self handleStartupErrors: startupErrors ].
		
	snapshotResult == nil
		ifTrue: [ self error: 'Failed to write image file (disk full?)' ].
		
	^ resuming! !
ImageSavePacer initialize!
